## clamav 0.98.7+dfsg

=== debian/changelog ===
clamav (0.98.7+dfsg-0ubuntu0.14.10.1) utopic-security; urgency=medium

  * Updated to 0.98.7 to fix multiple issues
    - CVE-2015-2170
    - CVE-2015-2221
    - CVE-2015-2222
    - CVE-2015-2305
    - CVE-2015-2668
  * Refreshed patches for 0.98.7:
    - d/p/0010-hardcode-LLVM-linker-flag-because-llvm-config-return.patch
    - d/p/0018-llvm-don-t-use-system-libs.patch
  * Removed upstreamed patches:
    - d/p/0014-remove-AC_CONFIG_SRCDIR-llvm-configure-from-libclama.patch

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 04 May 2015 12:02:16 -0400

clamav (0.98.6+dfsg-0ubuntu0.14.10.1) utopic-security; urgency=medium

  * Updated to 0.98.6 to fix security issues, including CVE-2014-9328.
  * Removed upstreamed patches:
    - d/p/0002-Add-an-additional-n-after-the-number-in-the-pidfile.patch
    - d/p/0017-Bump-.so-version-number.patch

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 30 Jan 2015 08:51:04 -0500

clamav (0.98.5+dfsg-0ubuntu0.14.10.1) utopic-security; urgency=medium

  * Updated to 0.98.5 to fix security issues, including CVE-2013-6497.
  * Removed upstreamed patches:
    - d/p/0004-Fix-FTBFS-with-LLVM-3.1-3.4.patch
    - d/p/0006-Fix-underlinking-with-llvm-in-libclamav-c-Makefile.a.patch
    - d/p/0007-bb-11028-fixed-a-deadlock-issue-with-fanotify-and-lo.patch
    - d/p/0010-Call-cl_initialize_crypto-in-cl_init.patch
  * Removed patches not needed in Ubuntu:
    - d/p/0005-enable-llvm-jit-on-kfreebsd.patch
    - d/p/0008-Fix-compiling-on-Hurd.patch
    - d/p/0009-Workaround-a-bug-in-libc-on-Hurd.patch
  * Added patches from vivid to fix FTBFS and .so version:
    - d/p/0006-remove-unnecessary-harmful-flags-from-libclamav.pc.patch
    - d/p/0010-hardcode-LLVM-linker-flag-because-llvm-config-return.patch
    - d/p/0014-remove-AC_CONFIG_SRCDIR-llvm-configure-from-libclama.patch
    - d/p/0018-llvm-don-t-use-system-libs.patch
    - d/p/0017-Bump-.so-version-number.patch
  * debian/control: added libncurses5-dev to Build-Depends.
  * debian/clamav-docs.docs: use wildcards, as some docs have changed.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 20 Nov 2014 10:01:09 -0500

=== debian/control ===
Source: clamav
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: ClamAV Team <pkg-clamav-devel@lists.alioth.debian.org>
Uploaders: Stephen Gran <sgran@debian.org>, Michael Meskes <meskes@debian.org>,
 Michael Tautschnig <mt@debian.org>, Scott Kitterman <scott@kitterman.com>,
 Sebastian Andrzej Siewior <sebastian@breakpoint.cc>,
 Andreas Cadhalpun <Andreas.Cadhalpun@googlemail.com>
Build-Depends: debhelper (>= 8.9.7), po-debconf, zlib1g-dev, libbz2-dev, libmilter-dev,
 perl, bc, check, libtommath-dev, libltdl-dev, electric-fence, libncurses5-dev, python,
 libxml2-dev, llvm-dev [i386 amd64 powerpc kfreebsd-amd64 kfreebsd-i386], dh-autoreconf,
 automake, pkg-config, faketime, libssl-dev, libcurl4-openssl-dev, libncurses5-dev
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/pkg-clamav/clamav.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-clamav/clamav.git;a=summary
Homepage: http://www.clamav.net/
XS-Testsuite: autopkgtest

Package: clamav-base
Architecture: all
Depends: ${misc:Depends}, adduser, ucf, logrotate
Recommends: clamav
Description: anti-virus utility for Unix - base package
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 This package mainly manages the clamav system account. It is not really
 useful without the clamav or clamav-daemon package.

Package: clamav-docs
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: anti-virus utility for Unix - documentation
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 This package contains the documentation for the ClamAV suite.

Package: clamav-dbg
Architecture: any
Depends: libclamav6, clamav (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Priority: extra
Section: debug
Description: debug symbols for ClamAV
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 This package contains the stripped debugging symbols for the ClamAV suite.

Package: clamav
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, clamav-freshclam | clamav-data, ${misc:Depends}
Recommends: clamav-base
Suggests: clamav-docs
Description: anti-virus utility for Unix - command-line interface
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 This package contains the command line interface. Features:
  - built-in support for various archive formats, including Zip, Tar,
    Gzip, Bzip2, OLE2, Cabinet, CHM, BinHex, SIS and others;
  - built-in support for almost all mail file formats;
  - built-in support for ELF executables and Portable Executable files
    compressed with UPX, FSG, Petite, NsPack, wwpack32, MEW, Upack and
    obfuscated with SUE, Y0da Cryptor and others;
  - built-in support for popular document formats including Microsoft
    Office and Mac Office files, HTML, RTF and PDF.
 .
 For scanning to work, a virus database is needed. There are two options
 for getting it:
  - clamav-freshclam: updates the database from Internet. This is
    recommended with Internet access.
  - clamav-data: for users without Internet access. The package is
    not updated once installed. The clamav-getfiles package allows
    creating custom packages from an Internet-connected computer.

Package: libclamav-dev
Section: libdevel
Architecture: any
Depends: libclamav6 (= ${binary:Version}), libssl-dev, libidn11-dev, libc6-dev | libc-dev, zlib1g-dev, libbz2-dev, libtommath-dev, ${misc:Depends}
Description: anti-virus utility for Unix - development files
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 The package contains the needed headers and libraries for
 developing software using the libclamav interface.
 .
 This library can be used to develop virus scanner applications.

Package: libclamav6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libclamunrar6
Description: anti-virus utility for Unix - library
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 For programs written using the libclamav library. Libclamav may be used to add
 virus protection into software. The library is thread-safe, and automatically
 recognizes and scans archives. Scanning is very fast and most of the time
 not noticeable.

Package: clamav-daemon
Architecture: any
Depends: ${shlibs:Depends}, clamav-base (= ${source:Version}), clamav-freshclam | clamav-data, lsb-base (>= 3.2-13), ucf, adduser, procps (>= 1:3.3.2), dpkg (>= 1.16.1), ${misc:Depends}
Suggests: daemon, clamav-docs, apparmor
Breaks: clamav-base (<< 0.98.1+dfsg-6)
Replaces: clamav-base (<< 0.98.1+dfsg-6)
Description: anti-virus utility for Unix - scanner daemon
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 This package contains the daemon and its command line interface,
 featuring:
  - fast, multi-threaded daemon;
  - easy integration with MTA's;
  - support for on-access scanning;
  - remote scanning;
  - able to be run supervised by daemon.

Package: clamav-testfiles
Architecture: all
Depends: ${misc:Depends}
Description: anti-virus utility for Unix - test files
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 This package contains files 'infected' with a test signature. The test
 signature (ClamAV-Test-Signature) should be detectable by all
 anti-virus programs.

Package: clamav-freshclam
Architecture: any
Conflicts: clamav-data, libclamav3, libclamav2
Provides: clamav-data
Suggests: clamav-docs, apparmor
Depends: ${misc:Depends}, clamav-base (>= ${source:Version}), ${shlibs:Depends}, ucf, logrotate, lsb-base (>= 3.2-13), procps (>= 1:3.3.2), dpkg (>= 1.16.1)
Description: anti-virus utility for Unix - virus database update utility
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 This package contains the freshclam program and scripts to automate virus
 database updating. It relies on an Internet connection, but can be
 run in a variety of ways to compensate for intermittent connections.

Package: clamav-milter
Architecture: any
Suggests: daemon, clamav-docs
Priority: extra
Recommends: clamav-daemon
Depends: ${shlibs:Depends}, clamav-base (>= ${source:Version}), clamav-freshclam | clamav-data, lsb-base (>= 3.2-13), ${misc:Depends}, adduser, ucf, logrotate, procps (>= 1:3.3.2), dpkg (>= 1.16.1)
Description: anti-virus utility for Unix - sendmail integration
 Clam AntiVirus is an anti-virus toolkit for Unix. The main purpose of
 this software is the integration with mail servers (attachment
 scanning). The package provides a flexible and scalable
 multi-threaded daemon in the clamav-daemon package, a command-line
 scanner in the clamav package, and a tool for automatic updating via
 the Internet in the clamav-freshclam package. The programs are based
 on libclamav6, which can be used by other software.
 .
 This package contains the ClamAV milter for use with sendmail. It can
 be configured to be run either standalone, or using clamav-daemon.

=== debian/rules ===
#! /usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Use automake 1.11 due to bug in automake-1.14.
# see: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=16375
# TODO: Remove this, when the bug is fixed.
export AUTOMAKE = automake
export ACLOCAL = aclocal

# This is needed to work around arch-specific quirks in the test suite.
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Get the hardening build flags and enable all compiler warnings:
CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) -Wall
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) -Wall
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

# Faketime on hurd currently (faketime 0.9.1-2) segfaults and newer versions FTBFS.
# Thus don't use it there.
# TODO: Use faketime on hurd again, once this is fixed.
ifneq (,$(findstring $(DEB_HOST_ARCH),hurd-i386))
  FT=
else
  # Get the date of the latest changelog entry.
  # This is used to make the build more binary reproducible.
  DAT  = $(shell dpkg-parsechangelog | grep Date: | sed s/Date:\ //)
  # Change the format to the only one that stops faketime from incresing the time.
  DATE = $(shell faketime "$(DAT)" date -u +"%Y-%m-%d %H:%M:%S")
  # NO_FAKE_STAT is necessary in order not to confuse make.
  FT=NO_FAKE_STAT="true" faketime -f -m "$(DATE)"
endif

# LLVM is only used on these archs, so no point in enabling it elsewhere
# To add new llvm/jit archs add it here and to the arch list for llvm-dev in
# debian/control.
ifeq (,$(filter $(DEB_HOST_ARCH), i386 amd64 powerpc kfreebsd-amd64 kfreebsd-i386))
  export enable_llvm=no
else
  # The llvm in squeeze (Debian 6) is older than the internal copy, so don't use it.
  ifeq ($(shell cut -c1 /etc/debian_version),6)
    SYSTEM_LLVM =
  else
    SYSTEM_LLVM = -with-system-llvm=/usr/bin/llvm-config
  endif
endif

# Set the configure options:
#	* add the build flags
#	* set various paths
#	* disable test for clamav user/group (--disable-clamav)
#	* disable building of the non-free libclamunrar (--disable-unrar)
#	* build clamav-milter (--enable-milter)
#	* enable workaround for broken DNS servers (--enable-dns-fix)
#	* assume the C compiler uses GNU ld (--with-gnu-ld)
#	* use system libraries instead of the embedded copies (--with-system-tommath, --without-included-ltdl, -with-system-llvm=/usr/bin/llvm-config)
CONFIG := CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
	--with-dbdir=/var/lib/clamav --sysconfdir=/etc/clamav \
	--disable-clamav --disable-unrar --enable-milter --enable-dns-fix \
	--with-gnu-ld --with-system-tommath --without-included-ltdl $(SYSTEM_LLVM)

DEBUG_OPTS=

# Enable debug code, if nostrip was given.
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
else
	DEBUG_OPTS += --enable-debug
endif

# The autotools in squeeze (Debian 6) are too old, so don't use autoreconf.
ifeq ($(shell cut -c1 /etc/debian_version),6)
  AUTORECONF =
else
  AUTORECONF = --with autoreconf
endif

# Use the default debhelper scripts, where possible.
# Enable parallel building and autoreconf.
%:
	dh $@ --parallel $(AUTORECONF)

override_dh_auto_configure:
	$(info DEB_BUILD_OPTIONS = $(DEB_BUILD_OPTIONS))
	$(info CFLAGS = $(CFLAGS))
	$(info CXXFLAGS = $(CXXFLAGS))
	$(info CPPFLAGS = $(CPPFLAGS))
	$(info LDFLAGS = $(LDFLAGS))
	# Check for unknown options in the configuration files.
	egrep '^#[[:alpha:]]' etc/clamd.conf.sample | sed -e 's/^#//' | awk '{print $$1}' | while read opt; do \
	  if ! grep -q "$${opt}" debian/clamav-daemon.postinst.in ; then \
	    echo "Unhandled option(clamd.conf): $${opt}"; \
	    exit 1; \
	  fi;\
	done;
	egrep '^#[[:alpha:]]' etc/freshclam.conf.sample | sed -e 's/^#//' | awk '{print $$1}' | while read opt; do \
	  if ! grep -q "$${opt}" debian/clamav-freshclam.postinst.in ; then \
	    echo "Unhandled option (freshclam.conf): $${opt}"; \
	    exit 1; \
	  fi;\
	done;
	egrep '^#[[:alpha:]]' etc/clamav-milter.conf.sample | sed -e 's/^#//' | awk '{print $$1}' | while read opt; do \
	  if ! grep -q "$${opt}" debian/clamav-milter.postinst.in ; then \
	    echo "Unhandled option (clamav-milter.conf): $${opt}"; \
	    exit 1; \
	  fi;\
	done;
	# Configure using the specified flags.
	$(FT) dh_auto_configure -- $(CONFIG) $(DEBUG_OPTS)

override_dh_auto_clean:
	# Update .po files for debconf.
	debconf-updatepo
	dh_auto_clean

clamav_build-indep:
	# Add common functions in config and postinst files.
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-base.postinst.in > debian/clamav-base.postinst

clamav_build-arch:
ifeq ($(PO2DEBCONF),yes)
	po2debconf -e utf8 debian/clamav-daemon.templates.master > debian/clamav-daemon.templates
	po2debconf -e utf8 debian/clamav-freshclam.templates.master > debian/clamav-freshclam.templates
	po2debconf -e utf8 debian/clamav-milter.templates.master > debian/clamav-milter.templates
	@echo debian/clamav-daemon.templates debian/clamav-freshclam.templates debian/clamav-milter.templates \
               >> debian/clean
endif
	# Add common functions in config and postinst files.
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-milter.init.in > debian/clamav-milter.init
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-milter.config.in > debian/clamav-milter.config
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-milter.postinst.in > debian/clamav-milter.postinst
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-daemon.config.in > debian/clamav-daemon.config
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-daemon.postinst.in > debian/clamav-daemon.postinst
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-daemon.init.in > debian/clamav-daemon.init
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-freshclam.init.in > debian/clamav-freshclam.init
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-freshclam.config.in > debian/clamav-freshclam.config
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-freshclam.postinst.in > debian/clamav-freshclam.postinst

# override_dh_auto_build-{indep,arch} doesn't work in squeeze (Debian 6).
ifeq ($(shell cut -c1 /etc/debian_version),6)
override_dh_auto_build: clamav_build-indep clamav_build-arch
	# Build all files.
	$(FT) dh_auto_build -- V=1
else
override_dh_auto_build-indep: clamav_build-indep
	# Build architecture-independent files.
	$(FT) dh_auto_build -i -- V=1

override_dh_auto_build-arch: clamav_build-arch
	# Build architecture-dependent files.
	$(FT) dh_auto_build -a -- V=1
endif

override_dh_auto_test:
ifneq (,$(filter alpha, $DEB_HOST_ARCH))
	@echo "Ignoring errors because of #521737"
	-dh_auto_test -- V=1
else
ifneq (,$(filter ia64 sparc, $DEB_HOST_ARCH))
	dh_auto_test -- EF_ALIGNMENT=8 V=1
else
	dh_auto_test -- V=1 VERBOSE=1
endif
endif

override_dh_strip:
	# Move the debug symbols to the debug package:
	dh_strip --dbg-package=clamav-dbg

override_dh_installinit:
	dh_installinit -pclamav-daemon
	# Don't change the postinst/postrm scripts for clamav-freshclam, as they need non-standard code.
	dh_installinit -pclamav-freshclam --noscripts
	dh_installinit -pclamav-milter

override_dh_installdocs-indep:
	dh_installdocs
	# Make the .rar test files which are no longer created
	cat test/.split/split.clam-v2.raraa test/.split/split.clam-v2.rarab >debian/clamav-testfiles/usr/share/clamav-testfiles/clam-v2.rar
	cat test/.split/split.clam-v3.raraa test/.split/split.clam-v3.rarab >debian/clamav-testfiles/usr/share/clamav-testfiles/clam-v3.rar

# Install the upstream ChangeLog.
override_dh_installchangelogs:
	dh_installchangelogs -pclamav-base ChangeLog
	dh_installchangelogs -pclamav-daemon ChangeLog

=== debian/watch ===
version=3
# The sf.net website doesn't work correctly at the moment, see https://bugs.debian.org/752384.
#opts="uversionmangle=s/(\d+)-*(rc)/$1~$2/,dversionmangle=s/\+dfsg//,pgpsigurlmangle=s/$/.sig/" \
#http://sf.net/clamav/clamav-(.*).tar.gz debian uupdate
opts="uversionmangle=s/(\d+)-*(rc)/$1~$2/,dversionmangle=s/\+dfsg//" \
https://github.com/vrtadmin/clamav-devel/tags /vrtadmin/clamav-devel/archive/clamav-(.*)\.tar\.gz

## clamav 0.99%2Bdfsg

=== libclamav/c++/llvm/lib/CodeGen/CMakeLists.txt ===
add_llvm_library(LLVMCodeGen
  AggressiveAntiDepBreaker.cpp
  Analysis.cpp
  BranchFolding.cpp
  CalcSpillWeights.cpp
  CallingConvLower.cpp
  CodePlacementOpt.cpp
  CriticalAntiDepBreaker.cpp
  DeadMachineInstructionElim.cpp
  DwarfEHPrepare.cpp
  ELFCodeEmitter.cpp
  ELFWriter.cpp
  GCMetadata.cpp
  GCMetadataPrinter.cpp
  GCStrategy.cpp
  IfConversion.cpp
  InlineSpiller.cpp
  IntrinsicLowering.cpp
  LLVMTargetMachine.cpp
  LatencyPriorityQueue.cpp
  LiveInterval.cpp
  LiveIntervalAnalysis.cpp
  LiveStackAnalysis.cpp
  LiveVariables.cpp
  LocalStackSlotAllocation.cpp
  LowerSubregs.cpp
  MachineBasicBlock.cpp
  MachineCSE.cpp
  MachineDominators.cpp
  MachineFunction.cpp
  MachineFunctionAnalysis.cpp
  MachineFunctionPass.cpp
  MachineFunctionPrinterPass.cpp
  MachineInstr.cpp
  MachineLICM.cpp
  MachineLoopInfo.cpp
  MachineModuleInfo.cpp
  MachineModuleInfoImpls.cpp
  MachinePassRegistry.cpp
  MachineRegisterInfo.cpp
  MachineSSAUpdater.cpp
  MachineSink.cpp
  MachineVerifier.cpp
  ObjectCodeEmitter.cpp
  OcamlGC.cpp
  OptimizePHIs.cpp
  PHIElimination.cpp
  Passes.cpp
  PeepholeOptimizer.cpp
  PostRAHazardRecognizer.cpp
  PostRASchedulerList.cpp
  PreAllocSplitting.cpp
  ProcessImplicitDefs.cpp
  PrologEpilogInserter.cpp
  PseudoSourceValue.cpp
  RegAllocFast.cpp
  RegAllocLinearScan.cpp
  RegAllocPBQP.cpp
  RegisterCoalescer.cpp
  RegisterScavenging.cpp
  RenderMachineFunction.cpp
  ScheduleDAG.cpp
  ScheduleDAGEmit.cpp
  ScheduleDAGInstrs.cpp
  ScheduleDAGPrinter.cpp
  ShadowStackGC.cpp
  ShrinkWrapping.cpp
  SimpleRegisterCoalescing.cpp
  SjLjEHPrepare.cpp
  SlotIndexes.cpp
  Spiller.cpp
  SplitKit.cpp
  Splitter.cpp
  StackProtector.cpp
  StackSlotColoring.cpp
  StrongPHIElimination.cpp
  TailDuplication.cpp
  TargetInstrInfoImpl.cpp
  TargetLoweringObjectFileImpl.cpp
  TwoAddressInstructionPass.cpp
  UnreachableBlockElim.cpp
  VirtRegMap.cpp
  VirtRegRewriter.cpp
  )

target_link_libraries (LLVMCodeGen LLVMCore LLVMScalarOpts)

=== debian/rules ===
#! /usr/bin/make -f

# Comment this out to turn off verbose mode.
#export DH_VERBOSE=1

# Automake 1.14 warns about not using subdir-objects,
# but using this option breaks the build, see:
#    http://debbugs.gnu.org/cgi/bugreport.cgi?bug=16375
#    http://debbugs.gnu.org/cgi/bugreport.cgi?bug=13928
# The following variables can be used to override the automake/aclocal versions.
#export AUTOMAKE = automake
#export ACLOCAL = aclocal

# This is needed to work around arch-specific quirks in the test suite.
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Get the hardening build flags and enable all compiler warnings:
CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) -Wall -D_FILE_OFFSET_BITS=64
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) -Wall -D_FILE_OFFSET_BITS=64
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# LLVM is only used on these archs, so no point in enabling it elsewhere
# To add new llvm/jit archs add it here and to the arch list for llvm-dev in
# debian/control.
# PowerPC is disabled until atleast llvm-3.8. As thing stand now MCJIT is
# broken in llvm-3.6. llvm v3.8 looks promissing but needs to be verified.
ifeq (,$(filter $(DEB_HOST_ARCH), i386 amd64 kfreebsd-amd64 kfreebsd-i386))
  export enable_llvm=no
else
  # The llvm in squeeze (Debian 6) is older than the internal copy, so don't use it.
  ifeq ($(shell cut -c1 /etc/debian_version),6)
    SYSTEM_LLVM =
  else
    SYSTEM_LLVM = -with-system-llvm=/usr/bin/llvm-config --with-llvm-linking=dynamic
    SYSTEM_LLVM = -with-system-llvm=/usr/lib/llvm-3.6/bin/llvm-config --with-llvm-linking=dynamic
  endif
endif

# Set the configure options:
#	* add the build flags
#	* set various paths
#	* disable test for clamav user/group (--disable-clamav)
#	* disable building of the non-free libclamunrar (--disable-unrar)
#	* build clamav-milter (--enable-milter)
#	* enable workaround for broken DNS servers (--enable-dns-fix)
#	* assume the C compiler uses GNU ld (--with-gnu-ld)
#	* use system libraries instead of the embedded copies (--with-system-tommath, --without-included-ltdl, -with-system-llvm=/usr/bin/llvm-config)
CONFIG := CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
	--with-dbdir=/var/lib/clamav --sysconfdir=/etc/clamav \
	--disable-clamav --disable-unrar --enable-milter --enable-dns-fix \
	--with-libjson \
	--with-gnu-ld $(SYSTEM_LLVM) \
	--with-systemdsystemunitdir=/lib/systemd/system

DEBUG_OPTS=

# Enable debug code, if nostrip was given.
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
else
	DEBUG_OPTS += --enable-debug
endif

# The autotools in squeeze (Debian 6) are too old, so don't use autoreconf.
# And don't use systemd.
ifeq ($(shell cut -c1 /etc/debian_version),6)
  AUTORECONF =
  SYSTEMD =
else
ifeq ($(shell cut -c1 /etc/debian_version),7)
  AUTORECONF = --with autoreconf
  SYSTEMD =
else
  AUTORECONF = --with autoreconf
  SYSTEMD = --with systemd
endif
endif

# Use the default debhelper scripts, where possible.
# Enable parallel building and conditionally autoreconf and systemd.
%:
	dh $@ --parallel $(AUTORECONF) $(SYSTEMD)

override_dh_auto_configure:
	$(info DEB_BUILD_OPTIONS = $(DEB_BUILD_OPTIONS))
	$(info CFLAGS = $(CFLAGS))
	$(info CXXFLAGS = $(CXXFLAGS))
	$(info CPPFLAGS = $(CPPFLAGS))
	$(info LDFLAGS = $(LDFLAGS))
	# Check for unknown options in the configuration files.
	egrep '^#[[:alpha:]]' etc/clamd.conf.sample | sed -e 's/^#//' | awk '{print $$1}' | while read opt; do \
	  if ! grep -q "$${opt}" debian/clamav-daemon.postinst.in ; then \
	    echo "Unhandled option(clamd.conf): $${opt}"; \
	    touch debian/exit; \
	  fi;\
	done; \
	egrep '^#[[:alpha:]]' etc/freshclam.conf.sample | sed -e 's/^#//' | awk '{print $$1}' | while read opt; do \
	  if ! grep -q "$${opt}" debian/clamav-freshclam.postinst.in ; then \
	    echo "Unhandled option (freshclam.conf): $${opt}"; \
	    touch debian/exit; \
	  fi;\
	done; \
	egrep '^#[[:alpha:]]' etc/clamav-milter.conf.sample | sed -e 's/^#//' | awk '{print $$1}' | while read opt; do \
	  if ! grep -q "$${opt}" debian/clamav-milter.postinst.in ; then \
	    echo "Unhandled option (clamav-milter.conf): $${opt}"; \
	    touch debian/exit; \
	  fi;\
	done; \
	[ ! -f debian/exit ] || (rm debian/exit && exit 1)
	# Configure using the specified flags.
	dh_auto_configure -- $(CONFIG) $(DEBUG_OPTS)

override_dh_auto_clean:
	# Update .po files for debconf.
	debconf-updatepo
	dh_auto_clean

clamav_build-indep:
	# Add common functions in config and postinst files.
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-base.postinst.in > debian/clamav-base.postinst

clamav_build-arch:
	# Add common functions in config and postinst files.
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-milter.init.in > debian/clamav-milter.init
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-milter.config.in > debian/clamav-milter.config
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-milter.postinst.in > debian/clamav-milter.postinst
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-daemon.config.in > debian/clamav-daemon.config
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-daemon.postinst.in > debian/clamav-daemon.postinst
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-daemon.init.in > debian/clamav-daemon.init
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-freshclam.init.in > debian/clamav-freshclam.init
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-freshclam.config.in > debian/clamav-freshclam.config
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-freshclam.postinst.in > debian/clamav-freshclam.postinst
	perl -pe 's~#COMMON-FUNCTIONS#~qx{cat debian/common_functions}~eg' < debian/clamav-freshclam.prerm.in > debian/clamav-freshclam.prerm

# override_dh_auto_build-{indep,arch} doesn't work in squeeze (Debian 6).
ifeq ($(shell cut -c1 /etc/debian_version),6)
override_dh_auto_build: clamav_build-indep clamav_build-arch
	# Build all files.
	dh_auto_build -- V=1
else
override_dh_auto_build-indep: clamav_build-indep
	# Build architecture-independent files.
	dh_auto_build -i -- V=1

override_dh_auto_build-arch: clamav_build-arch
	# Build architecture-dependent files.
	dh_auto_build -a -- V=1
endif

override_dh_auto_test:
ifneq (,$(filter armhf, $(DEB_HOST_ARCH)))
	@echo "Ignoring errors because of #521737"
	-dh_auto_test -- V=1
else
ifneq (,$(filter ia64 sparc, $(DEB_HOST_ARCH)))
	T=900 dh_auto_test -- EF_ALIGNMENT=8 V=1 VERBOSE=1
else
	T=900 dh_auto_test -- V=1 VERBOSE=1
endif
endif

override_dh_strip:
	# Move the debug symbols to the debug package:
	dh_strip --dbg-package=clamav-dbg

override_dh_installinit:
	dh_installinit -pclamav-daemon
	# Don't change the postinst/postrm scripts for clamav-freshclam, as they need non-standard code.
	dh_installinit -pclamav-freshclam --noscripts
	dh_installinit -pclamav-milter

override_dh_installdocs-indep:
	dh_installdocs
	# Make the .rar test files which are no longer created
	cat test/.split/split.clam-v2.raraa test/.split/split.clam-v2.rarab >debian/clamav-testfiles/usr/share/clamav-testfiles/clam-v2.rar
	cat test/.split/split.clam-v3.raraa test/.split/split.clam-v3.rarab >debian/clamav-testfiles/usr/share/clamav-testfiles/clam-v3.rar

# Install the upstream ChangeLog.
override_dh_installchangelogs:
	dh_installchangelogs -pclamav-base ChangeLog
	dh_installchangelogs -pclamav-daemon ChangeLog
	dh_installchangelogs -pclamav-dbg ChangeLog
	dh_installchangelogs -pclamav-docs ChangeLog
	dh_installchangelogs -pclamav-freshclam ChangeLog
	dh_installchangelogs -pclamav-milter ChangeLog
